<template>
	<xn-form-container
		:title="
			formData.uid ? (disabled ? '查看采集人员信息维护' : '编辑监测采集人员信息维护') : '增加监测采集人员信息维护'
		"
		:width="700"
		:visible="visible"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :columns="columns" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="人员姓名：" name="name">
				<a-input v-model:value="formData.name" :disabled="disabled" placeholder="请输入人员姓名" allow-clear />
			</a-form-item>
			<a-form-item label="手机号：" name="phone">
				<a-input v-model:value="formData.phone" :disabled="disabled" placeholder="请输入手机号" allow-clear />
			</a-form-item>
			<a-form-item label="联系地址：" name="address">
				<a-input v-model:value="formData.address" :disabled="disabled" placeholder="请输入地址" allow-clear />
			</a-form-item>
			<a-form-item label="所属行政管理部门" name="orgName">
				<a-select
					class="select-box"
					:disabled="disabled"
					v-model:value="formData.orgName"
					:size="size"
					style="width: 100%"
					placeholder="请选择"
				>
					<a-select-option v-for="item in auditStatus" :key="item.id" :value="item.name"
						>{{ item.name }}
					</a-select-option>
				</a-select>
			</a-form-item>
			<a-form-item label="站点" name="priceMonitorName">
				<a-input v-model:value="formData.priceMonitorName" :disabled="disabled" placeholder="请输入站点" allow-clear />
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button v-if="disabled !== true" type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="userCollectForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import userCollectApi from '@/api/basic.info/userCollectApi'
	import unReporCityApi from '@/api/basic.info/unReporCityApi.js'
	const auditStatus = ref([])

	// 抽屉状态
	const visible = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)
	const disabled = ref(false)
	onMounted(() => {
		getSearchData()
	})
	// 打开抽屉
	const onOpen = (record, flag) => {
		visible.value = true
		console.log(record)
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
		disabled.value = !!flag
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		visible.value = false
	}
	// 市州下拉框数据
	const getSearchData = () => {
		unReporCityApi.unReporCityquery().then((res) => {
			auditStatus.value = res
		})
	}
	// 默认要校验的
	const formRules = {}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value.validate().then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			userCollectApi
				.userCollectSubmitForm(formDataParam, formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
